
Declare Function ftrOpen Lib "FTRUN32.DLL" (ByVal hInstance As Long, ByVal lpszFile As String, ByRef lphftr As Long) As Long
Declare Function ftrClose Lib "FTRUN32.DLL" (ByVal hftr As Long) As Long

Declare Function ftrSetShellValue Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByVal ShellValue As Double) As Long
Declare Function ftrGetShellValue Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByRef lpShellValue As Double, ByRef lpNoHitFlag As Long) As Long

Declare Function ftrSetCodeValue Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByVal CodeValue As Long) As Long
Declare Function ftrGetCodeValue Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByRef CodeValue As Long, ByRef NoHitFlag As Long) As Long

Declare Function ftrSetDefaultValues Lib "FTRUN32.DLL" (ByVal hftr As Long) As Long

Declare Function ftrTrace Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal TraceOn As Long) As Long
Declare Function ftrOnlineWriteProtection Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal Enable As Long) As Long

Declare Function ftrBackup Lib "FTRUN32.DLL" (ByVal hftr As Long) As Long

Declare Function ftrGetInfo Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal InfoTopic As Long) As Long
Declare Function ftrGetIONameByIndex Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByVal ioNameBufSize As Long, ByVal lpioName As String) As Long
Declare Function ftrGetIORange Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByRef lpMinValue As Double, ByRef lpMaxValue As Double) As Long
Declare Function ftrGetIORangeEx Lib "FTRUN32.DLL" (ByVal hftr As Long, ByVal ioIndex As Long, ByRef lpMinValue As Double, ByRef lpMaxValue As Double, ByRef nBufSize As Long, ByVal lpCategoryNames As String) As Long



'Variables for the FTRUN-API.
Private hftrLunarLander As Long ' this is a handle to identify the fuzzy system
Private ftrOk As Boolean 'this flag indicates, whether the fuzzy system is open




Dim Lunar_Descent_Model_num_engines
Dim saved_thrust
Dim saved_ISP
Dim saved_MassFlowRate

Dim Lunar_Descent_Model_Update_Inputs
Dim Lunar_Descent_Model_Update_Outputs

'==========================================================================
' Lunar_Descent_Model_Update() fctn
'==========================================================================
Function Lunar_Descent_Model_Update( argArray )

	Dim retVal

	If IsEmpty(argArray(0)) Then

		' do compute

		retVal = Lunar_Descent_Model_Update_compute( argArray )

	ElseIf argArray(0) = "register" Then

		Lunar_Descent_Model_Update_globalVar = -1

		retVal = Lunar_Descent_Model_Update_register()

	ElseIf argArray(0) = "compute" Then

		' do compute

		retVal = Lunar_Descent_Model_Update_compute( argArray )

	Else

		' bad call

		retVal = Empty

	End If


	Lunar_Descent_Model_Update = retVal

End Function

Function Lunar_Descent_Model_Update_register()

	ReDim descripStr(3), argStr(3)

	descripStr(0)="ArgumentType = Output"
	descripStr(1)="Name = Status"
	descripStr(2)="ArgumentName = status"

	argStr(0) = descripStr

	ReDim descripStr(3)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = TotalMass"  ' out of astrogator
	descripStr(2)="ArgumentName = Mass" 'in thi vb scipt

    	argStr(1) = descripStr

	ReDim descripStr(4)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Lunar_a_sub_t"  ' fm astrogator accel need to have to get desired velocity
	descripStr(2)="ArgumentName = Lunar_a_sub_t" 
	descripStr(3)="Type = CalcObject"

	argStr(2) = descripStr

	Lunar_Descent_Model_Update_register = argStr

End Function


Function Lunar_Descent_Model_Update_compute( stateData)
	
' The following allow inputs and outputs to be called via c structure syntax

	Set Lunar_Descent_Model_Update_Inputs = g_GetPluginArrayInterface("Lunar_Descent_Model_Update_Inputs")
	Set Lunar_Descent_Model_Update_Outputs = g_GetPluginArrayInterface("Lunar_Descent_Model_Update_Outputs")

	Dim NomThrst
	Dim returnValue(4), thrust, ISP, mass, a_sub_t, target_thrust, num_engines
	Dim commanded_thrust

	g = 1.62 	   ' gravitational acelleration of moon
       
        NomThrst = 44041.66515 ' 9900 lbs Nominal thrust in N

	mass = stateData(Lunar_Descent_Model_Update_Inputs.Mass)
	a_sub_t = stateData(Lunar_Descent_Model_Update_Inputs.Lunar_a_sub_t)

        target_thrust = (a_sub_t + g)*mass   ' calculated necessary thrust for landing

'	MsgBox "target thrust " & target_thrust & "NomThrst" & NomThrst & vbNewline

	commanded_thrust = target_thrust

	if target_thrust > NomThrst then			' 9900 lbs force
		commanded_thrust = NomThrst
	end if
                                                                           
	returnValue(Lunar_Descent_Model_Update_Outputs.status) = "Still Okay"
	saved_thrust = commanded_thrust
	saved_MassFlowRate = commanded_thrust/(saved_ISP*9.80665)

	Lunar_Descent_Model_Update_compute = returnValue

End Function

Function LoadFuzzyLogicModel
	'load fuzzy logic system (FTRUN file *.ftr)
 	 Pfad1 = App.Path + "\LunarLander.ftr"
  	ftrOK = ftrOpen(App.hInstance, Pfad1, hftrTraffic&)

End Function


Function FuzzyEngine

	Dim OkVel As Boolean
	Dim OkAlt As Boolean
	Dim OkThrust as Boolean

  	'The value of this variable has been changed in the form
  	'Thus, set the corresponding input variable of the fuzzy system

  	If (ftrOk) Then
		'Velocity
    		OkVel = ftrSetShellValue(hftrLunarLander, 0, Velocity)
		'Altitude
		OkAlt = ftrSetShellValue(hftrLunarLander, 0, Altitude)

  	End If
  		
  	'Compute the output variables of the fuzzy system
		OkThrust = ftrGetShellValue(hftrLunarLander, 2, Value, 0)  



End Function

