
Dim Lunar_Descent_Model_num_engines
Dim saved_thrust
Dim saved_ISP
Dim saved_MassFlowRate

Dim Lunar_Descent_Model_Update_mode3_Inputs
Dim LLunar_Descent_Model_Update_mode3_Outputs

'==========================================================================
' Lunar_Descent_Model_Update() fctn
'==========================================================================
Function Lunar_Descent_Model_Update_mode3( argArray )

	Dim retVal

	If IsEmpty(argArray(0)) Then

		' do compute

		retVal = Lunar_Descent_Model_Update_mode3_compute( argArray )

	ElseIf argArray(0) = "register" Then

		Lunar_Descent_Model_Update_globalVar = -1

		retVal = Lunar_Descent_Model_Update_mode3_register()

	ElseIf argArray(0) = "compute" Then

		' do compute

		retVal = Lunar_Descent_Model_Update_mode3_compute( argArray )

	Else

		' bad call

		retVal = Empty

	End If


	Lunar_Descent_Model_Update_mode3 = retVal

End Function

Function Lunar_Descent_Model_Update_mode3_register()

	ReDim descripStr(3), argStr(3)

	descripStr(0)="ArgumentType = Output"
	descripStr(1)="Name = Status"
	descripStr(2)="ArgumentName = status"

	argStr(0) = descripStr

	ReDim descripStr(3)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = TotalMass"
	descripStr(2)="ArgumentName = Mass"

    	argStr(1) = descripStr

	ReDim descripStr(4)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Lunar_R_dot"
	descripStr(2)="ArgumentName = Lunar_R_dot"
	descripStr(3)="Type = CalcObject"

	argStr(2) = descripStr

	Lunar_Descent_Model_Update_mode3_register = argStr

End Function


Function Lunar_Descent_Model_Update_mode3_compute( stateData)
	
' The following allow inputs and outputs to be called via c structure syntax

	Set Lunar_Descent_Model_Update_mode3_Inputs = g_GetPluginArrayInterface("Lunar_Descent_Model_Update_mode3_Inputs")
	Set Lunar_Descent_Model_Update_mode3_Outputs = g_GetPluginArrayInterface("Lunar_Descent_Model_Update_mode3_Outputs")

	Dim NomThrst
	Dim returnValue(4), Lunar_R_dot, thrust, ISP, mass, a_sub_t_lg, target_thrust, num_engines
	Dim commanded_thrust

	g = 1.62 	   ' gravitational acelleration of moon
       
        NomThrst = 44041.66515 ' 9900 lbs Nominal thrust in N

	mass = stateData(Lunar_Descent_Model_Update_mode3_Inputs.Mass)
	Lunar_R_dot = stateData(Lunar_Descent_Model_Update_mode3_Inputs.Lunar_R_dot)

        target_thrust = (Lunar_R_dot/-1.2192)*mass*g    ' calculated necessary thrust for landing

'	MsgBox "target acceleration " & a_sub_t & vbNewline

	commanded_thrust = target_thrust

	if target_thrust > NomThrst then			' 9900 lbs force
		commanded_thrust = NomThrst
	end if
                                                                           
	returnValue(Lunar_Descent_Model_Update_mode3_Outputs.status) = "Still Okay"
	saved_thrust = commanded_thrust
	saved_MassFlowRate = commanded_thrust/(saved_ISP*9.80665)

	Lunar_Descent_Model_Update_mode3_compute = returnValue

End Function

